'
' Windows - Clipboard
' version 0.1
' (c) 2011 Stefan Wurzinger
'

#Include Once "windows.bi"
#Include Once "crt.bi"

Declare Function SetClipboardText (ByRef Daten As Const String, ByVal hWin As HWND = 0) As Integer
Declare Function SetClipboardTextZ (ByVal Daten As ZString ptr, ByVal sz As Integer, ByVal hWin As HWND = 0) As Integer


Function SetClipboardText (ByRef Daten As Const String, ByVal hWin As HWND = 0) As Integer
	Dim lptstrCopy As LPTSTR
	Dim hglbCopy As HGLOBAL
	Dim sz As Integer = Len(Daten)+1
	if OpenClipboard(hWin) = 0 Then Return 1
	EmptyClipboard()
	hglbCopy = GlobalAlloc(GMEM_MOVEABLE, sz) 
	If hglbCopy = 0 Then CloseClipboard() : Return 2
	lptstrCopy = GlobalLock(hglbCopy)
	memcpy(lptstrCopy, StrPtr(Daten), sz)
	GlobalUnlock(hglbCopy)
	SetClipboardData(CF_TEXT, hglbCopy)
	CloseClipboard()
End Function

'sz exklusiv abschlieendes 0 byte
Function SetClipboardTextZ (ByVal Daten As ZString Ptr, ByVal sz As Integer, ByVal hWin As HWND = 0) As Integer
	Dim lptstrCopy As LPTSTR
	Dim hglbCopy As HGLOBAL
	if OpenClipboard(hWin) = 0 Then Return 1
	EmptyClipboard()
	hglbCopy = GlobalAlloc(GMEM_MOVEABLE, sz+1) 
	If hglbCopy = 0 Then CloseClipboard() : Return 2
	lptstrCopy = GlobalLock(hglbCopy)
	memcpy(lptstrCopy, Daten, sz+1)
	GlobalUnlock(hglbCopy)
	SetClipboardData(CF_TEXT, hglbCopy)
	CloseClipboard()
End Function

